/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.stimmeingabe.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingang;
import de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingangUK;

public abstract class AbstractErgebnisGueltigerEingangDAO extends de.ivu.elect.jee.entity.AbstractDAO<ErgebnisGueltigerEingang,
        de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingangPK
    , ErgebnisGueltigerEingangUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractErgebnisGueltigerEingangDAO.class);

  public AbstractErgebnisGueltigerEingangDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingangPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public ErgebnisGueltigerEingang findByPrimaryKey(
        de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingangPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected ErgebnisGueltigerEingang findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(ErgebnisGueltigerEingang.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: ByErgebnisAndGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: DELETE FROM ErgebnisGueltigerEingang ege WHERE ege.ergebnis = ?1 AND EXISTS(SELECT ee FROM Ergebniseingang ee WHERE ege.ergebniseingang = ee AND ee.wahldurchfuehrungsgebiet IN (?2))<br>
      * SQL: <br>
      */
     public Integer deleteByErgebnisAndGebiet( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebiete) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebieteCheckedAndAttached =  gebiete ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("ERGEBNIS_GUELTIGER_EINGANG.ByErgebnisAndGebiet")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, gebieteCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("deleteByErgebnisAndGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("ErgebnisGueltigerEingang, deleteByErgebnisAndGebiet - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", gebiete:'"+gebiete+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteByErgebnisAndGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountGueltigeEingaengeByErgebnisNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM ErgebnisGueltigerEingang o WHERE o.ergebnis = ?1<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountGueltigeEingaengeByErgebnis( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("ERGEBNIS_GUELTIGER_EINGANG.CountGueltigeEingaengeByErgebnis")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountGueltigeEingaengeByErgebnis - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("ErgebnisGueltigerEingang, findByCountGueltigeEingaengeByErgebnis - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountGueltigeEingaengeByErgebnis(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebnis = ?1<br>
      * SQL: <br>
      */
     public java.util.List<ErgebnisGueltigerEingang> findByErgebnis( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("ERGEBNIS_GUELTIGER_EINGANG.Ergebnis")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByErgebnis - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("ErgebnisGueltigerEingang, findByErgebnis - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnis(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebniseingangNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebniseingang = ?1<br>
      * SQL: <br>
      */
     public java.util.List<ErgebnisGueltigerEingang> findByErgebniseingang( @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang ergebniseingang) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang ergebniseingangCheckedAndAttached =  checkAndAttach(ergebniseingang, de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang.class, "ergebniseingang"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("ERGEBNIS_GUELTIGER_EINGANG.Ergebniseingang")
                              .setParameter(1, ergebniseingangCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("ErgebnisGueltigerEingang, findByErgebniseingang - NonUniqueResultException, Parameter: "
           + ", ergebniseingang:'"+ergebniseingang+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebniseingang(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndErgebniseingangEingabeHashCodeNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM ErgebnisGueltigerEingang obj WHERE obj.ergebnis.wahl =?1 AND UPPER(obj.ergebniseingang.eingabeHashCode) LIKE UPPER(?2)<br>
      * SQL: <br>
      */
     public java.util.List<ErgebnisGueltigerEingang> findByWahlAndErgebniseingangEingabeHashCode( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String eingabeHashCodeLikePattern) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  String eingabeHashCodeLikePatternCheckedAndAttached =  checkAndAttach(eingabeHashCodeLikePattern, String.class, "eingabeHashCodeLikePattern"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("ERGEBNIS_GUELTIGER_EINGANG.WahlAndErgebniseingangEingabeHashCode")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, eingabeHashCodeLikePatternCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("ErgebnisGueltigerEingang, findByWahlAndErgebniseingangEingabeHashCode - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", eingabeHashCodeLikePattern:'"+eingabeHashCodeLikePattern+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndErgebniseingangEingabeHashCode(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndErgebniseingangsartGebietnummerGebietsartnameNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebnis.wahl =?1 AND o.ergebniseingang.ergebniseingangsart=?2 AND o.ergebniseingang.wahldurchfuehrungsgebiet.nummer = ?3 AND o.ergebniseingang.wahldurchfuehrungsgebiet.gebietsart.name = ?4<br>
      * SQL: <br>
      */
     public java.util.List<ErgebnisGueltigerEingang> findByWahlAndErgebniseingangsartGebietnummerGebietsartname( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsart,  @javax.annotation.Nonnull String gebietNummer,  @javax.annotation.Nonnull String gebietsartName) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsartCheckedAndAttached =  checkAndAttach(ergebniseingangsart, de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart.class, "ergebniseingangsart"); ;
		  			  String gebietNummerCheckedAndAttached =  checkAndAttach(gebietNummer, String.class, "gebietNummer"); ;
		  			  String gebietsartNameCheckedAndAttached =  checkAndAttach(gebietsartName, String.class, "gebietsartName"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("ERGEBNIS_GUELTIGER_EINGANG.WahlAndErgebniseingangsartGebietnummerGebietsartname")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, ergebniseingangsartCheckedAndAttached)
                                        .setParameter(3, gebietNummerCheckedAndAttached)
                                        .setParameter(4, gebietsartNameCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndErgebniseingangsartGebietnummerGebietsartname - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("ErgebnisGueltigerEingang, findByWahlAndErgebniseingangsartGebietnummerGebietsartname - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", ergebniseingangsart:'"+ergebniseingangsart+"'"
           + ", gebietNummer:'"+gebietNummer+"'"
           + ", gebietsartName:'"+gebietsartName+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndErgebniseingangsartGebietnummerGebietsartname(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndErgebniseingangsartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebnis.wahl =?1 AND o.ergebniseingang.ergebniseingangsart=?2<br>
      * SQL: <br>
      */
     public java.util.List<ErgebnisGueltigerEingang> findByWahlAndErgebniseingangsart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsartCheckedAndAttached =  checkAndAttach(ergebniseingangsart, de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart.class, "ergebniseingangsart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("ERGEBNIS_GUELTIGER_EINGANG.WahlAndErgebniseingangsart")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, ergebniseingangsartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("ErgebnisGueltigerEingang, findByWahlAndErgebniseingangsart - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", ergebniseingangsart:'"+ergebniseingangsart+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndErgebniseingangsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingangUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingangUK uk,
        de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingangPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingang findByUK(de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingangUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}